var ServicesDrawer = React.createClass({
	getInitialState: function() {
		return {
			data:[],
		};
	},
	componentDidMount: function() {
		var self = this;
		$.get(this.props.source, function(response) {
			if (this.isMounted()) {
				this.setState({
					data: response
				});
			}
		}.bind(this));
	},
	render:function() {
		var items = this.state.data || [];
		var nArrays = Math.ceil(items.length / 3);
		var holder = [];
		var n = 0;

		for(var i = 0; i < nArrays; i++) {

			var object = {};
			object.key = i;	
			object.array = [];

			for(var j = 0; j < items.length; j++) {	
				if(j == 3 || n == items.length)
					break;	
				object.array.push(items[n]);
				n++;
			}

			holder.push(object);
		}

		return (
			<div>
				{holder.map(function(row) {
					return <ServiceList key={row.key} items={row.array} />
				})}
			</div>
			)
	}
});


var ServiceList = React.createClass({
	render:function() {
		return (			
			<div className="row">
				<div className="row">
				{this.props.items.map(function(item) {
					return <ServiceItemWrapper key={item.name} image={item.image} social={item.social} name={item.name} content={item.content} link={item.link}/>;
				})}
				</div>
				<hr/>
			</div>
			)
	}
});

var ServiceItemWrapper = React.createClass({
	render:function() {
		var image = "/img/logo.png";

		var url = <a title="web" className="btn btn-primary" href={this.props.link} role="button"><i className="fa fa-globe"></i></a>
		var facebook = null;
		var twitter = null;
		var youtube = null;
		var github = null;
		var ios = null;
		var android = null;

		if(this.props.social !== null) {
			if(this.props.social.facebook)
				facebook = <a title="facebook" className="btn btn-primary" href={this.props.social.facebook} role="button"><i className="fa fa-facebook-square"></i></a>
			if(this.props.social.twitter)
				twitter = <a title="twitter" className="btn btn-primary" href={this.props.social.twitter} role="button"><i className="fa fa-twitter"></i></a>
			if(this.props.social.youtube)
				youtube = <a title="youtube" className="btn btn-danger" href={this.props.social.youtube} role="button"><i className="fa fa-youtube-play"></i></a>
			if(this.props.social.github)
				github = <a title="github" className="btn btn-primary" href={this.props.social.github} role="button"><i className="fa fa-github-alt"></i></a>
			if(this.props.social.ios)
				ios = <a title="ios" className="btn btn-default" href={this.props.social.ios} role="button"><i className="fa fa-apple"></i></a>
			if(this.props.social.android)
				android = <a title="android" className="btn btn-success" href={this.props.social.android} role="button"><i className="fa fa-android"></i></a>
		}

		if(this.props.image)
			image = this.props.image;

		return (
			<div className="col-md-4 tool">
				<p className="text-center"><img src={image} className="toolImage" alt={this.props.name} /></p>
				<h3><a title={this.props.name} href={this.props.link}>{this.props.name}</a></h3>
	          	<p>{this.props.content}</p>
	          	<p className="shareBtn">
	          		{url}
	          		{facebook}
	          		{twitter}
	          		{youtube}
	          		{github}
	          		{ios}
	          		{android}
	          	</p>
          	</div>
			)
	}
});


ReactDOM.render(<ServicesDrawer source="/api/items/list?category=herramientas" />, document.getElementById('tools'));
